﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Pdg.Sdl2
{
    public enum KeyCode
    {
        Unknown                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_UNKNOWN
        ,Return                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_RETURN
        ,Escape                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_ESCAPE
        ,Backspace                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_BACKSPACE 
        ,Tab                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_TAB
        ,Space                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_SPACE
        ,Exclaim                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_EXCLAIM
        ,QuoteDbl                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_QUOTEDBL
        ,Hash                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_HASH
        ,Percent                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_PERCENT
        ,Dollar                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_DOLLAR
        ,Ampersand                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_AMPERSAND 
        ,Quote                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_QUOTE
        ,LeftParen                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_LEFTPAREN 
        ,RightParen                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_RIGHTPAREN
        ,Asterisk                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_ASTERISK
        ,Plus                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_PLUS
        ,Comma                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_COMMA 
        ,Minus                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_MINUS 
        ,Period                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_PERIOD
        ,Slash                                                                                           =SDL2.SDL.SDL_Keycode.SDLK_SLASH  
        ,_0                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_0 
        ,_1                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_1 
        ,_2                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_2 
        ,_3                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_3 
        ,_4                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_4 
        ,_5                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_5 
        ,_6                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_6 
        ,_7                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_7 
        ,_8                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_8 
        ,_9                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_9 
        ,Colon                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_COLON 
        ,Semicolon                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_SEMICOLON 
        ,Less                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_LESS 
        ,Equals                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_EQUALS 
        ,Greater                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_GREATER
        ,Question                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_QUESTION
        ,At                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_AT 
        ,LeftBracket                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_LEFTBRACKET
        ,Backslash                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_BACKSLASH
        ,RightBracket                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_RIGHTBRACKET
        ,Caret                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_CARET
        ,Underscore                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_UNDERSCORE
        ,Backquote                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_BACKQUOTE
        ,A                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_a 
        ,B                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_b 
        ,C                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_c 
        ,D                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_d 
        ,E                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_e 
        ,F                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_f 
        ,G                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_g 
        ,H                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_h 
        ,I                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_i 
        ,J                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_j 
        ,K                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_k 
        ,L                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_l 
        ,M                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_m 
        ,N                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_n 
        ,O                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_o 
        ,P                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_p 
        ,Q                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_q 
        ,R                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_r 
        ,S                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_s 
        ,T                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_t 
        ,U                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_u 
        ,V                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_v 
        ,W                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_w 
        ,X                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_x 
        ,Y                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_y 
        ,Z                                                                                           =SDL2.SDL.SDL_Keycode.SDLK_z  
        ,CapsLock                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_CAPSLOCK
        ,F1                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_F1 
        ,F2                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_F2 
        ,F3                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_F3 
        ,F4                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_F4 
        ,F5                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_F5 
        ,F6                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_F6 
        ,F7                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_F7 
        ,F8                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_F8 
        ,F9                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_F9 
        ,F10                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_F10
        ,F11                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_F11
        ,F12                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_F12
        ,PrintScreen                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_PRINTSCREEN
        ,ScrollLock                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_SCROLLLOCK
        ,Pause                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_PAUSE
        ,Insert                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_INSERT
        ,Home                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_HOME
        ,PageUp                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_PAGEUP
        ,Delete                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_DELETE
        ,End                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_END
        ,PageDown                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_PAGEDOWN
        ,Right                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_RIGHT
        ,Left                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_LEFT
        ,Down                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_DOWN 
        ,Up                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_UP
        ,NumlockClear                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_NUMLOCKCLEAR
        ,KP_Divide                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_KP_DIVIDE
        ,KP_Multiply                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_KP_MULTIPLY
        ,KP_Minus                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_KP_MINUS
        ,KP_Plus                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_KP_PLUS
        ,KP_Enter                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_KP_ENTER
        ,KP_1                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_KP_1
        ,KP_2                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_KP_2
        ,KP_3                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_KP_3
        ,KP_4                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_KP_4
        ,KP_5                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_KP_5
        ,KP_6                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_KP_6
        ,KP_7                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_KP_7
        ,KP_8                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_KP_8
        ,KP_9                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_KP_9
        ,KP_0                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_KP_0
        ,KP_Period                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_KP_PERIOD 
        ,Application                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_APPLICATION
        ,Power                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_POWER
        ,KP_Equals                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_KP_EQUALS
        ,F13                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_F13
        ,F14                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_F14
        ,F15                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_F15
        ,F16                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_F16
        ,F17                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_F17
        ,F18                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_F18
        ,F19                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_F19
        ,F20                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_F20
        ,F21                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_F21
        ,F22                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_F22
        ,F23                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_F23
        ,F24                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_F24
        ,Execute                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_EXECUTE
        ,Help                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_HELP
        ,Menu                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_MENU
        ,Select                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_SELECT
        ,Stop                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_STOP
        ,Again                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_AGAIN
        ,Undo                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_UNDO
        ,Cut                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_CUT
        ,Copy                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_COPY
        ,Paste                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_PASTE
        ,Find                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_FIND
        ,Mute                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_MUTE
        ,VolumeUp                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_VOLUMEUP
        ,VolumeDown                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_VOLUMEDOWN
        ,KP_Comma                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_KP_COMMA
        ,KP_Equalsas400                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_KP_EQUALSAS400 
        ,AltErase                                                                                                 =SDL2.SDL.SDL_Keycode.SDLK_ALTERASE        
        ,SysrRq                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_SYSREQ 
        ,Cancel                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_CANCEL 
        ,Clear                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_CLEAR 
        ,Prior                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_PRIOR 
        ,Return2                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_RETURN2 
        ,Separator                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_SEPARATOR 
        ,Out                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_OUT 
        ,Oper                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_OPER 
        ,ClearAgain                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_CLEARAGAIN
        ,Crsel                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_CRSEL 
        ,Exsel                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_EXSEL 
        ,Kp_00                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_KP_00 
        ,Kp_000                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_KP_000 
        ,ThousandsSeparator                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_THOUSANDSSEPARATOR 
        ,DecimalSeparator                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_DECIMALSEPARATOR 
        ,CurrencyUnit                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_CURRENCYUNIT 
        ,CurrencySubunit                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_CURRENCYSUBUNIT 
        ,KP_LeftParen                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_KP_LEFTPAREN 
        ,KP_RightParen                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_KP_RIGHTPAREN 
        ,KP_LeftBrace                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_KP_LEFTBRACE 
        ,KP_RightBrace                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_KP_RIGHTBRACE 
        ,KP_Tab                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_KP_TAB 
        ,KP_Backspace                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_KP_BACKSPACE 
        ,KP_A                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_KP_A 
        ,KP_B                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_KP_B 
        ,KP_C                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_KP_C 
        ,KP_D                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_KP_D 
        ,KP_E                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_KP_E 
        ,KP_F                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_KP_F 
        ,KP_Xor                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_KP_XOR 
        ,KP_Power                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_KP_POWER
        ,KP_Percent                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_KP_PERCENT
        ,KP_Less                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_KP_LESS
        ,KP_Greater                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_KP_GREATER
        ,KP_Ampersand                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_KP_AMPERSAND
        ,KP_DblAmpersand                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_KP_DBLAMPERSAND 
        ,KP_VerticalBar                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_KP_VERTICALBAR 
        ,KP_DblverticalBar                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_KP_DBLVERTICALBAR 
        ,KP_Colon                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_KP_COLON
        ,KP_Hash                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_KP_HASH 
        ,KP_Space                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_KP_SPACE
        ,KP_At                                                                                                 =SDL2.SDL.SDL_Keycode.SDLK_KP_AT        
        ,KP_Exclam                                                                                           =SDL2.SDL.SDL_Keycode.SDLK_KP_EXCLAM  
        ,KP_MemStore                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_KP_MEMSTORE 
        ,KP_MemRecall                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_KP_MEMRECALL
        ,KP_MemClear                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_KP_MEMCLEAR 
        ,KP_MemAdd                                                                                                 =SDL2.SDL.SDL_Keycode.SDLK_KP_MEMADD        
        ,KP_MemSubtract                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_KP_MEMSUBTRACT 
        ,KP_MemMultiply                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_KP_MEMMULTIPLY 
        ,KP_MemDivide                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_KP_MEMDIVIDE 
        ,KP_PlusMinus                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_KP_PLUSMINUS 
        ,KP_Clear                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_KP_CLEAR 
        ,KP_ClearEntry                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_KP_CLEARENTRY
        ,KP_Binary                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_KP_BINARY
        ,KP_Octal                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_KP_OCTAL
        ,KP_Decimal                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_KP_DECIMAL
        ,KP_Hexadecimal                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_KP_HEXADECIMAL 
        ,LCtrl                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_LCTRL 
        ,LShift                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_LSHIFT
        ,LAlt                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_LALT 
        ,LGui                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_LGUI 
        ,RCtrl                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_RCTRL 
        ,RShift                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_RSHIFT
        ,RAlt                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_RALT 
        ,RGui                                                                                          =SDL2.SDL.SDL_Keycode.SDLK_RGUI 
        ,Mode                                                                                              =SDL2.SDL.SDL_Keycode.SDLK_MODE     
        ,AudioNext                                                                                             =SDL2.SDL.SDL_Keycode.SDLK_AUDIONEXT    
        ,AudioPrev                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_AUDIOPREV
        ,AudioStop                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_AUDIOSTOP
        ,AudioPlay                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_AUDIOPLAY
        ,AudioMute                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_AUDIOMUTE
        ,MediaSelect                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_MEDIASELECT
        ,Www                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_WWW
        ,Mail                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_MAIL
        ,Calculator                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_CALCULATOR
        ,Computer                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_COMPUTER
        ,AC_Search                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_AC_SEARCH
        ,AC_Home                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_AC_HOME
        ,AC_Back                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_AC_BACK
        ,AC_Forward                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_AC_FORWARD
        ,AC_Stop                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_AC_STOP
        ,AC_Refresh                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_AC_REFRESH
        ,AC_Bookmarks                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_AC_BOOKMARKS
        ,BrightnessDown                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_BRIGHTNESSDOWN
        ,BrightnessUp                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_BRIGHTNESSUP
        ,DisplaySwitch                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_DISPLAYSWITCH
        ,KbdillumToggle                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_KBDILLUMTOGGLE
        ,KbdillumDown                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_KBDILLUMDOWN
        ,KbdillumUp                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_KBDILLUMUP
        ,Eject                                                                                         =SDL2.SDL.SDL_Keycode.SDLK_EJECT
        ,Sleep                                                                                         = SDL2.SDL.SDL_Keycode.SDLK_SLEEP
    }
    public class KeyEvent:Event
    {
        public uint Timestamp { get; private set; }
        public uint WindowId { get; private set; }
        public int ScanCode { get; private set; }
        public KeyCode KeyCode { get; private set; }
        public ushort ModState { get; private set; }
        public bool IsPressed { get; private set; }
        public bool IsRepeat { get; private set; }
        internal KeyEvent(EventType eventType, uint timestamp, uint windowId, bool isPressed, bool isRepeat,int scanCode, KeyCode keyCode, ushort modState)
            :base(eventType)
        {
            Timestamp = timestamp;
            WindowId = windowId;
            IsPressed = isPressed;
            IsRepeat = isRepeat;
            ModState = modState;
            ScanCode = scanCode;
            KeyCode = keyCode;
        }
    }
}
